import random

import peqnp as cnf

for bits in range(10, 20):
    n = 2 * 100

    D = [random.randint(1, 2 ** bits) for _ in range(n)]

    print('D   : {}'.format(D))

    cnf.engine(sum(D).bit_length())

    bins, sub, com = cnf.subsets(D, n // 2, complement=True)

    assert sum(sub) == sum(com)

    if cnf.satisfy(turbo=True, cnf_path='maximum_constrained_partition_{}_bits_n{}'.format(bits, n), solve=False):
        sub = [D[i] for i in range(n) if bins.binary[i]]
        com = [D[i] for i in range(n) if not bins.binary[i]]
        print(sum(sub), len(sub), sub)
        print(sum(com), len(com), com)
        print('\n')
    # else:
    #    print('Infeasible ...')